import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class fling extends PApplet {

public void resetGame(){

  guys = new HashSet(); 
  guys.add(new downer(3,10));
  guys.add(new upper(17,3));

  eggs = new HashSet();
 // eggs.add(new egg(11,10));

  additionalRotateBackground = 0.0f;
  upcomingRotateBackgroundOffset = 0.0f;
  world = getWorld();
lifepoints = 0;

framecount = 0;

  numberBorn = 1; 
  numberKilled = 0;  
  
 finalanimation = 0;
   nextTurn = NOTURN;
}


public void setup(){
  frameRate(FPS);
  size(600 ,600);

  soundAtSetup();
  guiAtSetup();
  imgBg = loadImage("rocket2andhull.png");
  imgTitle = loadImage("TitleScreen.png");
  imgEnding = loadImage("ending.png");
}



public void draw(){
  background(0,0,30);

  if(gameState == START){
    image(imgTitle,0,0);
    return ; 
  }
  //ENDING!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  if(gameState == ENDING){

    finalanimation--;
    
  pushMatrix();
    translate(WORLDCENTERX,WORLDCENTERY+finalanimation);

  image(imgBg,imgBg.width / -2.0f+2,imgBg.height / -2.0f+40);
  popMatrix();


    drawFinalScore();
    return ; 
  }


  framecount++;

  if(GAMELASTS - (framecount / FPS) <= 0){
    gameState = ENDING;
    return;
  }


  //FIRST TICK OF ROUND: WE PLUG IN THE CLICKED ON ROTATION
  //WE ALSO TELL EACH GUY THAT IF THEY MOVED VIA ANIMATION, THEY SHOULD 
  //'KNOW' THAT THEY ARE AT THEIR NEW LOCATION
  if(framecount % FRAMESPERROUND == 0){
    activeTurn = nextTurn;

    if(nextTurn != NOTURN){
      if(activeTurn == TURNCW){
        upcomingRotateBackgroundOffset = PI/2;  
      }
      if(activeTurn == TURNCCW){
        upcomingRotateBackgroundOffset = -PI/2;  
      }

    }

    nextTurn = NOTURN;
    Iterator i = guys.iterator();
    while(i.hasNext()){
      guy g = (guy)i.next(); 
      if(g.registerMoveOrDie()){ //true if the guy is dead
        i.remove();
        numberKilled++;
      }
    }

  }
  //TICKS BEFORE 'TURNSTEP', WE ARE MOSTLY JUST *visually* ROTATING
  //TURNSTEP is how many frames we do the turn in (should be less than that FRAMESPERROUND!)
  if((activeTurn != NOTURN)&&(framecount % FRAMESPERROUND) < TURNSTEP){
    rot += STEPAMOUNT * activeTurn; //isn't that clever, our constants for activeTurn are +- 1...
  }
  //AT TURNSTEP EXACTLY,  WE MENTALLY ROTATE THE BLOCKS IN THE GRAPH AND PUT THE GUYS IN NEW ROTATED SPOTS
  //WE ALSO HAVE EACH GUY THINK ABOUT HIS MOVE, FALLING OR MOVING....
  if((framecount % FRAMESPERROUND) == TURNSTEP){
    if((activeTurn != NOTURN)) {

      rot = 0.0f;
      if(activeTurn == TURNCW){
        world = rotateWorldCW(world);
        Iterator i = guys.iterator();
        while(i.hasNext()){
          guy g = (guy)i.next(); 
          g.shiftCW();
        }
        i = eggs.iterator();
        while(i.hasNext()){
          egg e = (egg)i.next(); 
          e.shiftCW();
        }
      } 
      else {
        world = rotateWorldCCW(world);
        Iterator i = guys.iterator();
        while(i.hasNext()){
          guy g = (guy)i.next(); 
          g.shiftCCW();
        }
        i = eggs.iterator();
        while(i.hasNext()){
          egg e = (egg)i.next(); 
          e.shiftCCW();
        }
      }
    }

    //we're kind of resetting the turning...
    //the trouble is we need to keep track of how much rotation of the 
    //background we're doing....
    additionalRotateBackground += upcomingRotateBackgroundOffset;
    upcomingRotateBackgroundOffset = 0.0f;
  Iterator   i = eggs.iterator();
  while(i.hasNext()){
    egg e = (egg)i.next(); 

    if(random(2) < 1){
        guys.add(new upper(e.x,e.y));
      } 
      else {
        guys.add(new downer(e.x,e.y));
      }
    i.remove();
    
  }

    //now lets maybe add in a guy, eh?
    if(random(chance) < 1){

      intXandY xy = findABlankSquare();
      numberBorn++;
     /*if(random(2) < 1){
        guys.add(new upper(xy.x,xy.y));
      } 
      else {
        guys.add(new downer(xy.x,xy.y));
      }*/
      eggs.add(new egg(xy.x,xy.y));
    }



    i = guys.iterator();
    while(i.hasNext()){
      guy g = (guy)i.next(); 
      g.calcMove();
    }



  } //end in MENTALLY ROTATE AND AND GUYS THINK TIME

  //AT GREATER THAN TURNSTEP IN THE ROUND, WE DO THE ANIMATIONS
  if((framecount % FRAMESPERROUND) > TURNSTEP){ //START MOVE ANIMATION TIME
    Iterator i = guys.iterator();
    while(i.hasNext()){
      guy g = (guy)i.next(); 
      g.move();
    }
  } //END IF MOVE ANIMATION TIME

  //record the world rotation etc
  pushMatrix();
  //move the "camera" middle of the world (for rotation)
  translate(WORLDCENTERX,WORLDCENTERY);
  if(rot != 0.0f){
    rotate(rot);
  }
  pushMatrix();
  rotate(additionalRotateBackground);  
  image(imgBg,imgBg.width / -2.0f+2,imgBg.height / -2.0f+40);
  popMatrix();

  drawWorld(); 
  Iterator i = guys.iterator();
  while(i.hasNext()){
    guy g = (guy)i.next(); 
    g.animate();
    g.draw();
  }
  i = eggs.iterator();
  while(i.hasNext()){
    egg e = (egg)i.next(); 
    e.animate();
    e.draw();
  }



  popMatrix();
  doGUI();
}

public void keyPressed()
{

  if(gameState == START || gameState == ENDING){
    if(key  == ' '){
      resetGame();
    if(gameState == START){
     switchMusic(); 
    }
      gameState = RUNNING;


    } 

  } 
  else {
    if(key  == 'q' || key == 'Q'){
      gameState = ENDING;
    } 

    if ( key == 'z' ||  key == 'Z' || keyCode == LEFT)
    {
      nextTurn = TURNCCW;
    }
    if ( key == 'x' ||  key == 'X' || keyCode == RIGHT)
    {
      nextTurn = TURNCW;
    }
  }
}


public void stop() {
  soundAtStop();
  super.stop();
}







final int BOXCOUNT = 19;
final int HEARTLOC = 9; //right in the middle, matey
final int BOXSIZE = 25; //in pixels
final int SCREENSIZE = 600;
final int WORLDCENTERX = SCREENSIZE / 2 ;
final int WORLDCENTERY = SCREENSIZE / 2;
final int FPS = 30;
final int FRAMESPERROUND = 30; //how many frames between times we can turn

final int WALL = 1;
final int HEART = 2;
final int EMPTY = 0;

final int TURNSTEP = 10; // needs to be less than FRAMESPERROUND, how many frames we're taking up to turn things
final float STEPAMOUNT = (PI / 2)/TURNSTEP; //quarter turn , 90 degrees divided by how many steps we're taking

float GAMELASTS = 120;//time the game lasts in seconds

final int NOTURN = 0;
//isn't that clever, our constants for activeTurn are +- 1...
//we can use that for our visual rotation
//(and my clever I mean kind of obvious)
final int TURNCW = 1; 
final int TURNCCW = -1;

final    float LEFTOFWORLD = (BOXSIZE  *  BOXCOUNT)*-.5f; 
final    float TOPOFWORLD = (BOXSIZE  *  BOXCOUNT)*-.5f;


final int START = 1;
final int RUNNING = 2;
final int ENDING = 3;

//actually global, not constant:
int world[][] = new int[BOXCOUNT][BOXCOUNT];

int framecount = 0;
float rot = 0.0f;
//guy g;
int nextTurn = NOTURN;
int activeTurn = NOTURN;

PImage imgArrowCW; 
PImage imgArrowCCW; 

HashSet guys = new HashSet();
HashSet eggs = new HashSet();
PImage imgBg;

//int score;
int gameState = START;
PImage imgTitle;
PImage imgEnding;


int   numberBorn;// = 2; 
int   numberKilled;// = 0;  


float additionalRotateBackground; 
float upcomingRotateBackgroundOffset;

int finalanimation;


float chance =  7;

int lifepoints = 0;
class downer extends guy{

  PImage imgWalkingLeft[] = new PImage[4] ;
  PImage imgWalkingRight[] = new PImage[4] ;
  PImage imgFallLeft ;
  PImage imgFallRight ;

  
downer(int startx,int starty){
  super(startx,starty);

  
    imgWalkingLeft[0] = loadImage("l_walker1.png");
    imgWalkingLeft[1] = loadImage("l_walker2.png");
    imgWalkingLeft[2] = loadImage("l_walker3.png");
    imgWalkingLeft[3] = loadImage("l_walker4.png");  
    imgWalkingRight[0] = loadImage("r_walker1.png");
    imgWalkingRight[1] = loadImage("r_walker2.png");
    imgWalkingRight[2] = loadImage("r_walker3.png");
    imgWalkingRight[3] = loadImage("r_walker4.png");  
    
    
    
    imgFallLeft = loadImage("l_walkprefall2.png");
    imgFallRight = loadImage("walkprefall2.png");
}
  public void calcMove(){
    pixelDeltaX = 0.0f;
    pixelDeltaY = 0.0f;
    //anything beneath feet?
    if(!hasBoxUnder(xSquare,ySquare)){
      calcFall();
    } else{
       pickAndMove(); 
    }
  }

  int FRAMESOFHOVER = 4;
  int FRAMESTOHOLD = 5;
  int currentFrame = (int)random(FRAMESOFHOVER);
  int timeTilChange = (int)random(FRAMESTOHOLD);

  public void animate(){
    
       if(dumb){
      if(lastDirMoved == 1){
        img = imgFallRight;
      }else {
        img = imgFallLeft;
      }
     return;   
    }
    
    if(lastDirMoved == 1){
      img = imgWalkingRight[currentFrame];
    } else {
      img = imgWalkingLeft[currentFrame];
      
    }
    timeTilChange --;
    if(timeTilChange <= 0){
      timeTilChange = FRAMESTOHOLD;
      currentFrame++;
      if(currentFrame >= FRAMESOFHOVER){
        currentFrame = 0;
      }    
    }
  }

public void checkIfDumb(){
  //println("checking for "+destBoxX+" "+destBoxY );
  int testy  = destBoxY;
   while(testy < BOXCOUNT && !hasBoxUnder(destBoxX,testy)){
      testy++;
    }
  if(testy ==  BOXCOUNT){
      dumb =true; 
  }
}




  public boolean hasBoxUnder(int x, int y){
    int checky = y + 1;
    if(getWorldContentsSafely(x,checky) == WALL){
      return true;
    }
    return false;
  } 
  public void calcFall(){
    destBoxX = xSquare;
    destBoxY = ySquare;
    float currentPixelX, currentPixelY;
    float destPixelX, destPixelY;

    while(destBoxY < BOXCOUNT && !hasBoxUnder(destBoxX,destBoxY)){
      destBoxY++;
    }

    currentPixelX = LEFTOFWORLD+(xSquare*BOXSIZE);
    currentPixelY = TOPOFWORLD+(ySquare*BOXSIZE);


    if(destBoxY == BOXCOUNT){ //FALLEN OUT OF BOTTOM
              screamdown();
        isDoomed = true;
    destPixelX = LEFTOFWORLD+(destBoxX*BOXSIZE);
    destPixelY = SCREENSIZE;

      } else {
            destPixelX = LEFTOFWORLD+(destBoxX*BOXSIZE);
            destPixelY = TOPOFWORLD+(destBoxY*BOXSIZE);
 
      }




    float fractionPerFrame = (FRAMESPERROUND-TURNSTEP);
    pixelDeltaX = (destPixelX  - currentPixelX) / fractionPerFrame;
    pixelDeltaY = (destPixelY  - currentPixelY)/ fractionPerFrame;
  }









}
class egg{
  int x,y;
  egg(int px, int py){
      x = px; 
      y = py;
      warpfx();
    
  }
  public void draw(){
      ellipseMode(CENTER);
      noStroke();
      fill(c);
      ellipse(LEFTOFWORLD+(x*BOXSIZE)+BOXSIZE/2,TOPOFWORLD+(y*BOXSIZE)+BOXSIZE/2,sz,sz);
  }
  float sz = 0;
  int c =  color(128+random(128),128+random(128),128+random(128)) ;
  int counter = 3;
  public void animate(){
    counter--;
    if(counter <= 0){
       c = color(128+random(128),128+random(128),128+random(128)) ;
       counter = 3;
    }
    sz++;
  }
  
    public void shiftCW(){
    int oldxsquare = x;
    int oldysquare = y;
    x = (BOXCOUNT-1)-oldysquare;
    y = oldxsquare;

  }
  public void shiftCCW(){
    int oldxsquare = x;
    int oldysquare = y;
    x = oldysquare;
    y = (BOXCOUNT-1)-oldxsquare;

  }
  
}

final int TIMEBAR_TOP = SCREENSIZE*9/10;
final int TIMEBAR_HEIGHT = SCREENSIZE/20;
final int TIMEBAR_MAXWIDTH = SCREENSIZE / 4;
final int TIMEBAR_LEFT = (SCREENSIZE - TIMEBAR_MAXWIDTH) / 2;

final int ARROW_TOP = SCREENSIZE*9/10;
final float ARROW_SIZE = 20;
final float ARROW_DIST_FROM_WALL = SCREENSIZE/10;

public void guiAtSetup(){
  imgArrowCW = loadImage("arrowcw.png"); 
  imgArrowCCW = loadImage("arrowccw.png"); 
  textFont(loadFont( "ArialNarrow-24.vlw"));
}

public void drawFinalScore(){
textAlign(CENTER);
fill(255);
 text("Thank You for your help in saving the Alien Lifeforms!", SCREENSIZE/2,SCREENSIZE/2-40);
 text("You scored "+lifepoints + " Lifepoints!", SCREENSIZE/2 ,SCREENSIZE/2);  
 text("You saved "+(numberBorn-numberKilled)+" Lifeforms!", SCREENSIZE/2 ,SCREENSIZE/2+40);// out of "+numberBorn,40,SCREENSIZE/2+40); 
 

 text("Press SpaceBar to Try Again!",SCREENSIZE/2,SCREENSIZE/2+100 ); 
textAlign(LEFT);  
}


public void doGUI(){
    drawTimeBar();
    drawArrows();
    drawScore();
    drawTimeRemaining();
    drawGuysLeft();
}

public void drawTimeRemaining(){
  String txt = "Lifepoints:"+lifepoints;
  strokeWeight(2);
  stroke(20,100,20);
  fill(80,180,80);
  rect(20,2,textWidth(txt),26);
  fill(0);
  
   text(txt,20,22);//+" chance is 1 in "+chance,0,20); 
}
public void drawGuysLeft(){
  String txt = "Lifeforms in Ship:"+guys.size();
  strokeWeight(2);
  stroke(20,100,20);
  fill(80,180,80);
  rect(180,2,textWidth(txt),26);
  fill(0);
  
   text(txt,180,22);//+" chance is 1 in "+chance,0,20); 
}


public void drawScore(){
    float timeGone = GAMELASTS - (framecount / FPS);
  int seconds = PApplet.parseInt(timeGone) % 60;
  int minutes = PApplet.parseInt(timeGone / 60);
  String showseconds = ""+seconds;
  if(showseconds.length() == 1){
     showseconds = "0"+showseconds; 
  }
  String txt = "Time Remaining: "+minutes+":"+showseconds;
  strokeWeight(2);

if(timeGone > 10){
  stroke(20,100,20);
  fill(80,180,80);
} else {
  stroke(100,20,20);
  fill(180,80,80);
  
}
  rect(400,2,textWidth(txt),26);
  fill(0);
  
   text(txt,400,22);//+" chance is 1 in "+chance,0,20); 
}



public void drawTimeBar(){
    float framesLeft = FRAMESPERROUND - (framecount % FRAMESPERROUND);
    float fracRemain = framesLeft /FRAMESPERROUND;
//  println(fracRemain);

  fill(200,200,255,255-(255*fracRemain));

    stroke(0);
    strokeWeight(2);
  
    float barWidth = TIMEBAR_MAXWIDTH  *  fracRemain;
    float barLeft = 0;
    if( nextTurn == NOTURN){
      barLeft = (SCREENSIZE/2)-(barWidth/2);
    }
    if( nextTurn == TURNCCW){
      barLeft = ARROW_DIST_FROM_WALL;//+ARROW_SIZE;
  
    }
    if( nextTurn == TURNCW){
      barLeft = SCREENSIZE - ARROW_DIST_FROM_WALL - barWidth;
    }
      
    rect(barLeft,TIMEBAR_TOP,barWidth  ,TIMEBAR_HEIGHT);  
  
}

public void drawArrows(){

  
  fill(128);
  rect(ARROW_DIST_FROM_WALL-7,ARROW_TOP+20,36,30);
  
fill(255);

if( nextTurn == TURNCCW){
  fill(200,0,0);
}
  text("Z",ARROW_DIST_FROM_WALL+4,ARROW_TOP+40);


  fill(128);
  rect(SCREENSIZE - ARROW_DIST_FROM_WALL - ARROW_SIZE-4,ARROW_TOP+20,36,30);


fill(255);

if( nextTurn == TURNCW){
  fill(200,0,0);
}


  text("X",SCREENSIZE - ARROW_DIST_FROM_WALL - ARROW_SIZE+7,ARROW_TOP+40);

  /*
if( nextTurn == TURNCW){
  rect(SCREENSIZE - ARROW_DIST_FROM_WALL - ARROW_SIZE,ARROW_TOP,ARROW_SIZE,ARROW_SIZE);
}*/
  image(imgArrowCCW,ARROW_DIST_FROM_WALL,ARROW_TOP);
 image(imgArrowCW,SCREENSIZE - ARROW_DIST_FROM_WALL - ARROW_SIZE,ARROW_TOP);
 
 
 
 fill(0);
  //text("Z",20,20);

}



abstract class guy {
  PImage img;
  //the x and y coordinate in the world grid
  int xSquare,ySquare;

  int movebehaviour;
  //deltas are how much we move per frame, based on the calculated move
  float pixelDeltaX = 0.0f, pixelDeltaY = 0.0f;
  //offset is the sum of all the deltas this round, we just add it to the position
  float pixelOffsetX = 0.0f, pixelOffsetY = 0.0f;

  int destBoxX = -1;
  int destBoxY = -1;

  int lastDirMoved = 1;

   boolean isDoomed = false;

  guy(int startx,int starty){

    xSquare = startx;
    ySquare = starty;

  if(random(2) < 1.0f){
     lastDirMoved = 1; 
  } else {
     lastDirMoved = -1;  }

    
  }

  public void draw(){

    image(img,LEFTOFWORLD+(xSquare*BOXSIZE)+pixelOffsetX,TOPOFWORLD+(ySquare*BOXSIZE)+pixelOffsetY);
    //line(0,0,destPixelX,destPixelY);
  }

  public void shiftCW(){
    int oldxsquare = xSquare;
    int oldysquare = ySquare;
    xSquare = (BOXCOUNT-1)-oldysquare;
    ySquare = oldxsquare;

  }
  public void shiftCCW(){
    int oldxsquare = xSquare;
    int oldysquare = ySquare;
    xSquare = oldysquare;
    ySquare = (BOXCOUNT-1)-oldxsquare;

  }

public abstract void animate();

public abstract void calcMove();
  public void move(){
    pixelOffsetX += pixelDeltaX;
    pixelOffsetY += pixelDeltaY;
  }

public void  pickAndMove(){
  lifepoints++;
  
  
//  println("MOVING");
  boolean leftIsOK = true;
  boolean rightIsOK = true;

  if(getWorldContentsSafely(xSquare-1,ySquare) != EMPTY){
        leftIsOK = false;    
  }
  if(getWorldContentsSafely(xSquare+1,ySquare) != EMPTY){
        rightIsOK = false;  
  }

  //if we can't move either, return
  if(! (leftIsOK || rightIsOK)){
    return;
  }
  if(leftIsOK && (! rightIsOK)){
      doPickedMove(-1);
      return;
  }
  if((!leftIsOK) && rightIsOK){
      doPickedMove(1);
      return;
  }
  
  //can go either way lets try to keep it moving the same direction
  doPickedMove(lastDirMoved);
  return;
}

public void doPickedMove(int dir){
//   println("MOVING TO "+dir); 

  float currentPixelX = LEFTOFWORLD+(xSquare*BOXSIZE);
  float destPixelX = LEFTOFWORLD+((dir+xSquare)*BOXSIZE);
   
    float fractionPerFrame = (FRAMESPERROUND-TURNSTEP);
    pixelDeltaX = (destPixelX  - currentPixelX) / fractionPerFrame;

  destBoxX = xSquare + dir;
  destBoxY = ySquare;// + dir;
   lastDirMoved = dir;
   
   checkIfDumb();
   
}

public abstract void checkIfDumb();
boolean dumb = false;

  //so here we have the guy 'know' where it is after the animation...
  //eventually this should return a boolean true if it's dead 
  public boolean registerMoveOrDie(){
  /*  if(destBoxX != -1){
    } else {
       println("DOHH"); 
    }
    if(destBoxY != -1){
    }
*/
      xSquare =  destBoxX; 
      ySquare =     destBoxY; 


    destBoxX = xSquare;
    destBoxY = ySquare;
    pixelOffsetX = 0.0f;
    pixelOffsetY = 0.0f;
    pixelDeltaX = 0.0f;
    pixelDeltaY = 0.0f;
    
    return isDoomed;
  }

}









AudioPlayer groove;
AudioPlayer ambi;
AudioSnippet song;
AudioSnippet warp;
AudioSnippet screamsnippetsup[];
AudioSnippet screamsnippetsdown[];


String screamfilesdown[] = 
{"descend_1.mp3",
"descend_2.mp3",
"descend_3.mp3",
"descend_4.mp3",
"descend_5.mp3",
"die_1.mp3",
"die_10.mp3",
"die_4.mp3",
"die_5.mp3",
"die_6.mp3",
"die_9.mp3"};

String screamfilesup[] = 
{"ascend_1.mp3",
"ascend_2.mp3",
"ascend_3.mp3",
"ascend_4.mp3",
"ascend_5.mp3",
"ascend_6.mp3",
"ascend_7.mp3",
"die_2.mp3",
"die_3.mp3",
"die_7.mp3",
"die_8.mp3"};

public void switchMusic(){
//println("SWITCHI");
  ambi.pause();
  groove.loop();
 
}

public void soundAtSetup(){
  Minim.start(this);

//  groove = minim.loadFile("ambience.mp3", 2048);
  groove = Minim.loadFile("loopable.mp3", 8192);
 // groove.loop();
//  groove.play();
  ambi  = Minim.loadFile("ambience.mp3", 8192);

ambi.loop();

warp = Minim.loadSnippet("warp_3.mp3");

  song = Minim.loadSnippet("ringin.wav");
//  song = minim.loadSnippet("die_2.mp3");

  screamsnippetsup = new AudioSnippet[screamfilesup.length];
  for(int i = 0; i < screamfilesup.length; i++){
     screamsnippetsup[i] =  Minim.loadSnippet(screamfilesup[i]);
  }
  screamsnippetsdown = new AudioSnippet[screamfilesdown.length];
  for(int i = 0; i < screamfilesdown.length; i++){
     screamsnippetsdown[i] =  Minim.loadSnippet(screamfilesdown[i]);
  }


}

public void warpfx(){
    warp.rewind();
    warp.play();
}

public void screamup(){
  int index = PApplet.parseInt(random(screamsnippetsup.length)); 
  screamsnippetsup[index].rewind();
    screamsnippetsup[index].play();
}
public void screamdown(){
  int index = PApplet.parseInt(random(screamsnippetsdown.length)); 
  screamsnippetsdown[index].rewind();
    screamsnippetsdown[index].play();
}

// 

public void soundAtStop(){
  warp.close();
  song.close();
   //always close Minim audio classes when you are done with them
  groove.close();
  ambi.close();
  
    for(int i = 0; i < screamfilesdown.length; i++){
     screamsnippetsdown[i].close();
     screamsnippetsup[i].close();
    }  
  // always stop Minim before exiting.
//  Minim.stop(); 
  
}
class upper extends guy{

  PImage imgHoverRight[] = new PImage[4] ;
  PImage imgHoverLeft[] = new PImage[4] ;
  PImage imgFallLeft ;
  PImage imgFallRight ;
  upper(int startx,int starty){
    super(startx,starty);
    imgHoverRight[0] = loadImage("levifrm1_2.png");
    imgHoverRight[1] = loadImage("levifrm2_2.png");
    imgHoverRight[2] = loadImage("levifrm3_2.png");
    imgHoverRight[3] = loadImage("levifrm4_2.png");
    imgHoverLeft[0] = loadImage("l_levifrm1_2.png");
    imgHoverLeft[1] = loadImage("l_levifrm2_2.png");
    imgHoverLeft[2] = loadImage("l_levifrm3_2.png");
    imgHoverLeft[3] = loadImage("l_levifrm4_2.png");

    imgFallLeft = loadImage("l_leviprefall3.png");
    imgFallRight = loadImage("leviprefall3.png");

  }
  public void calcMove(){
    pixelDeltaX = 0.0f;
    pixelDeltaY = 0.0f;
    //anything over hread ?
    if(!hasBoxOver(xSquare,ySquare)){
      calcRise();
    } else{
       pickAndMove(); 
    }
  }

  int FRAMESOFHOVER = 4;
  int FRAMESTOHOLD = 5;
  int currentFrame = (int)random(FRAMESOFHOVER);
  int timeTilChange = (int)random(FRAMESTOHOLD);

  public void animate(){
    
    if(dumb){
      if(lastDirMoved == 1){
        img = imgFallRight;
      }else {
        img = imgFallLeft;
      }
     return;   
    }
   
  if(lastDirMoved == 1){
      img = imgHoverRight[currentFrame];
    } else {
      img = imgHoverLeft[currentFrame];
      
    }    timeTilChange --;
    if(timeTilChange <= 0){
      timeTilChange = FRAMESTOHOLD;
      currentFrame++;
      if(currentFrame >= FRAMESOFHOVER){
        currentFrame = 0;
      }    
    }
  }


public void checkIfDumb(){
 //println("checking for "+destBoxX+" "+destBoxY );
  int testy  = destBoxY;
    while(testy >= 0 && !hasBoxOver(destBoxX,testy)){
      testy--;
    }
  if(testy < 0){
      dumb =true; 
  }
}


  public boolean hasBoxOver(int x, int y){
    int checky = y - 1;
    if(getWorldContentsSafely(x,checky) == WALL){
      return true;
    }
    return false;
  } 

  public void calcRise(){
    destBoxX = xSquare;
    destBoxY = ySquare;
    float currentPixelX, currentPixelY;
    float destPixelX, destPixelY;

    while(destBoxY >= 0 && !hasBoxOver(destBoxX,destBoxY)){
      destBoxY--;
    }

    currentPixelX = LEFTOFWORLD+(xSquare*BOXSIZE);
    currentPixelY = TOPOFWORLD+(ySquare*BOXSIZE);


    if(destBoxY < 0){ //FALLEN OUT OF top
              screamup();
      isDoomed = true;
      destPixelX = LEFTOFWORLD+(destBoxX*BOXSIZE);
      destPixelY = 0-BOXCOUNT*BOXSIZE; 

    } 
    else {
      destPixelX = LEFTOFWORLD+(destBoxX*BOXSIZE);
      destPixelY = TOPOFWORLD+(destBoxY*BOXSIZE);

    }
    float fractionPerFrame = (FRAMESPERROUND-TURNSTEP);
    pixelDeltaX = (destPixelX  - currentPixelX) / fractionPerFrame;
    pixelDeltaY = (destPixelY  - currentPixelY)/ fractionPerFrame;
//    println("pixelDeltaY:"+pixelDeltaY+" currentPixelY:"+currentPixelY+" destPixelY:"+destPixelY );
  }




}

//assumes all rotation is done
public void drawWorld(){
    strokeWeight(2);
//    noStroke();

  float startX = (BOXSIZE  *  BOXCOUNT)*-.5f;
  float startY = (BOXSIZE  *  BOXCOUNT) * -.5f;
  for(int x = 0; x < BOXCOUNT; x++){
    for(int y = 0; y < BOXCOUNT; y++){
      if(world[x][y]==EMPTY || world[x][y]==HEART){
        noStroke();//stroke(128);
        fill(70,70,70);
        rect(startX+(x*BOXSIZE),startY+(y*BOXSIZE), BOXSIZE,BOXSIZE);
      }
      /*if(world[x][y]  0){
        if(world[x][y] == 2) fill(255,200,200); //heart color
        rect(startX+(x*BOXSIZE),startY+(y*BOXSIZE), BOXSIZE,BOXSIZE);
        rect(startX+(x*BOXSIZE),startY+(y*BOXSIZE), BOXSIZE,BOXSIZE);
      }*/
    } 
  }

}




// note this kind of assumes WORLDSIZE = 19....

public int[][] getWorld(){

return   new int[][]
{//FULL WORLD
  /*
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
  {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
  
  */
 //latest:: 
 
  {1,1,1,1,1,1,0,1,1,1,0,1,1,1,1,1,1,0,1},
{0,0,1,1,0,0,0,1,1,1,0,0,0,1,1,0,0,0,1},
{1,0,1,1,0,1,1,1,1,1,1,1,0,1,1,0,1,1,1},
{1,0,1,1,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0},
{1,0,0,0,1,0,1,0,1,1,0,1,0,1,0,1,1,0,1},
{1,1,1,0,1,0,0,0,1,0,0,0,0,1,0,1,0,0,1},
{1,1,0,0,0,1,0,1,1,0,1,0,1,0,0,0,0,1,1},
{0,0,0,1,0,0,0,0,1,0,0,1,1,0,1,0,1,1,1},
{1,1,1,1,1,0,1,0,1,0,1,1,0,0,1,0,1,0,0},
{1,1,0,0,0,0,1,0,0,0,0,0,0,1,1,1,1,0,1},
{0,0,0,1,0,1,0,0,1,0,1,0,1,1,1,1,1,0,1},
{1,1,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,0,1},
{1,0,0,0,0,1,0,0,1,1,1,0,0,1,0,0,1,1,1},
{1,0,1,1,0,0,1,0,0,0,0,1,0,1,0,1,1,1,1},
{1,0,1,1,1,0,1,1,0,1,0,1,0,0,0,1,1,1,1},
{1,0,0,1,1,0,0,0,0,1,0,0,1,0,1,0,0,0,1},
{1,1,0,1,1,1,1,1,0,1,1,0,1,0,0,0,1,0,1},
{1,1,0,0,0,1,1,0,0,1,1,0,0,1,1,1,1,0,0},
{1,1,1,1,0,1,1,0,1,1,1,1,0,1,1,1,1,1,1}



/*
//older
 
{1,1,1,1,1,1,0,1,1,1,1,1,1,0,1,1,0,1,1},
{1,1,1,1,0,0,0,1,1,1,1,1,0,0,0,0,0,0,1},
{0,0,0,1,0,1,0,0,0,0,0,1,0,1,1,1,1,0,1},
{1,1,0,1,1,1,1,1,0,1,1,1,0,1,1,1,1,0,1},
{1,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,0,0,1},
{1,0,1,0,1,0,1,1,0,0,0,0,1,0,1,1,1,0,1},
{1,0,1,0,0,0,0,1,1,1,1,0,1,0,1,1,1,0,0},
{0,0,1,1,0,1,0,0,0,0,0,0,1,0,0,0,0,0,1},
{1,0,0,0,0,1,1,1,1,1,1,1,1,0,1,1,1,0,1},
{1,0,1,1,1,1,0,0,0,2,0,0,0,0,1,1,1,0,1},
{1,0,0,0,0,0,0,1,1,1,1,0,1,1,1,1,1,1,1},
{1,1,1,1,1,1,0,1,1,1,1,0,0,0,0,0,0,0,1},
{1,0,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,0,0},
{0,0,1,0,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1},
{1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,0,0,0,1},
{1,1,0,0,0,0,0,0,0,1,0,0,0,0,0,1,1,0,1},
{1,1,1,0,1,1,1,1,0,1,0,1,0,1,1,1,1,0,0},
{1,0,0,0,0,0,1,1,0,0,0,1,0,0,0,0,0,0,1},
{1,0,1,1,1,0,1,1,1,1,1,1,1,1,0,1,1,1,1}*/
};
  
}

public int[][] rotateWorldCW(int source[][]){
  int [][] dest = new int[BOXCOUNT][BOXCOUNT];
  for(int x = 0; x < BOXCOUNT; x++){
    for(int y = 0; y < BOXCOUNT; y++){
      dest[x][y] = source[y][(BOXCOUNT-1)-x];
    } 
  }
  return dest;
}

public int[][] rotateWorldCCW(int source[][]){
  int [][] dest = new int[BOXCOUNT][BOXCOUNT];
  for(int x = 0; x < BOXCOUNT; x++){
    for(int y = 0; y < BOXCOUNT; y++){
      dest[x][y] = source[(BOXCOUNT-1)-y][x];
    } 
  }
  return dest;
}

public int getWorldContentsSafely(int x, int y){
   if(x < 0 || x >= BOXCOUNT || y < 0 || y >= BOXCOUNT){
      return EMPTY;
   } 
   return world[x][y];
}

//blank and not directly in line at some point??
public intXandY findABlankSquare(){
  int x, y;
  do{
    x = 2+PApplet.parseInt(random(BOXCOUNT-4));
    y = 2+PApplet.parseInt(random(BOXCOUNT-4));

   // println("trying "+x+" and "+y+" THERE IS "+world[x][y]);
  } while(world[x][y] != EMPTY);
//    println("!!!!ACCEPTUI "+x+" and "+y+" THERE IS "+world[x][y]);
  return new intXandY(x,y);
}

class intXandY {
  int x, y;
   intXandY(int px, int py){
     x = px;
    y = py; 
   } 
   
}




  static public void main(String args[]) {
    PApplet.main(new String[] { "fling" });
  }
}
